#!/bin/bash 

# Quick and dirty script to get users to reboot their clients, 

days_up=$(/usr/bin/uptime | egrep "[0-9]+ days" -o | cut -d " " -f 1) 
maxdays=45

if [[ $days_up && $days_up -gt $maxdays ]];then
  # User on smhi ? 
  /bin/ping ad.smhi.se -c1 &> /dev/null || exit 0 
  
  # Gotta love this, 
  users=$(
    for user in $(users | tr " " "\n" | sort | uniq); 
    do 
      /usr/bin/ldapsearch -D 'cn=ldapstat,ou=People,dc=ad,dc=smhi,dc=sé \
      -w ldapstatus -b 'ou=people,dc=ad,dc=smhi,dc=sé cn=$user mail | 
      grep mail: | cut -d " " -f2
    done | tr "\n" " "
  )

  # Construct a nice message, 
  msg1="Hej ! \n\nDenna klient har inte bootat om på $days_up dagar.\n"
  msg2="Det är viktigt att du gör det så att du får in alla "
  msg3="säkerhetuppdateringar samt så att du alltid kör på den senaste kerneln "
  msg4="från Red Hat.\n\nMed vänliga hälsningar, TFO Linux" 
 
  if [[ -z $users ]]; then
    # No users logged in, try to look up the owner through facter, 
    users=$(echo $(facter -p smhi_username)@smhi.se)
  fi

  if [[ $users == "@smhi.se" ]];then
    # Could not find any valid user for this client, report to base. 
    echo "Could not find any users for $HOSTNAME (client been up for $days_up days)" |
    mail -s "Linda-reboot-message sent" tfolinux@smhi.se
  else
    # Send it to the users(s), 
    echo -e ${msg1}${msg2}${msg3}${msg4} | mail -s "Starta om din klient" $users

    echo "Sent reboot message to $users (client has been up for $days_up days)" |
    mail -s "Linda-reboot-message sent" tfolinux@smhi.se
  fi
fi

exit 0
